function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function getEllipsisVisibleContent(_ref) {
  var _visibleContent;
  var content = _ref.content,
    rows = _ref.rows,
    rowHeight = _ref.rowHeight,
    containerDOM = _ref.containerDOM;
  if (!rows || typeof rows !== 'number' || typeof content !== 'string' || !containerDOM) {
    return content;
  }

  // 显示复制的容器, 隐藏原容器,
  var containerDuplicate = containerDOM.cloneNode(false);
  containerDOM.parentNode.insertBefore(containerDuplicate, containerDOM.nextElementSibling);
  containerDOM.classList.add("hide");

  // Force line clamp
  containerDuplicate.classList.add("typography-ellipsis");
  containerDuplicate.style.webkitLineClamp = rows;
  containerDuplicate.style.height = rows * (rowHeight || 20) + 'px';

  // If scrollHeight > clientHeight, Intercept the content
  var visibleContent = '';
  var words = content.split('');
  var _iterator = _createForOfIteratorHelper(words),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var word = _step.value;
      visibleContent += word;
      containerDuplicate.innerHTML = visibleContent;
      if (containerDuplicate.scrollHeight > containerDuplicate.clientHeight) {
        // 为...留空间
        visibleContent = visibleContent.slice(0, visibleContent.length - 4);
        break;
      }
    }

    // If expandable, Keep intercepting the content
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  if (((_visibleContent = visibleContent) === null || _visibleContent === void 0 ? void 0 : _visibleContent.length) !== (content === null || content === void 0 ? void 0 : content.length)) {
    visibleContent = visibleContent.slice(0, visibleContent.length - 4);
    visibleContent += '...';
  }

  // 还原容器
  containerDuplicate.parentNode.removeChild(containerDuplicate);
  containerDOM.classList.remove("hide");
  return visibleContent;
}
export default getEllipsisVisibleContent;